"""File generated by TLObjects' generator. All changes will be ERASED"""
from ...tl.tlobject import TLObject
from ...tl.tlobject import TLRequest
from typing import Optional, List, Union, TYPE_CHECKING
import os
import struct
if TYPE_CHECKING:
    from ...tl.types import TypePaymentRequestedInfo, TypeInputPaymentCredentials



class ClearSavedInfoRequest(TLRequest):
    CONSTRUCTOR_ID = 0xd83d70c1
    SUBCLASS_OF_ID = 0xf5b399ac

    def __init__(self, credentials=None, info=None):
        """
        :param Optional[bool] credentials:
        :param Optional[bool] info:

        :returns Bool: This type has no constructors.
        """
        self.credentials = credentials  # type: Optional[bool]
        self.info = info  # type: Optional[bool]

    def to_dict(self):
        return {
            '_': 'ClearSavedInfoRequest',
            'credentials': self.credentials,
            'info': self.info
        }

    def __bytes__(self):
        return b''.join((
            b'\xc1p=\xd8',
            struct.pack('<I', (0 if self.credentials is None or self.credentials is False else 1) | (0 if self.info is None or self.info is False else 2)),
        ))

    @classmethod
    def from_reader(cls, reader):
        flags = reader.read_int()

        _credentials = bool(flags & 1)
        _info = bool(flags & 2)
        return cls(credentials=_credentials, info=_info)


class GetPaymentFormRequest(TLRequest):
    CONSTRUCTOR_ID = 0x99f09745
    SUBCLASS_OF_ID = 0xa0483f19

    def __init__(self, msg_id):
        """
        :param int msg_id:

        :returns payments.PaymentForm: Instance of PaymentForm.
        """
        self.msg_id = msg_id  # type: int

    def to_dict(self):
        return {
            '_': 'GetPaymentFormRequest',
            'msg_id': self.msg_id
        }

    def __bytes__(self):
        return b''.join((
            b'E\x97\xf0\x99',
            struct.pack('<i', self.msg_id),
        ))

    @classmethod
    def from_reader(cls, reader):
        _msg_id = reader.read_int()
        return cls(msg_id=_msg_id)


class GetPaymentReceiptRequest(TLRequest):
    CONSTRUCTOR_ID = 0xa092a980
    SUBCLASS_OF_ID = 0x590093c9

    def __init__(self, msg_id):
        """
        :param int msg_id:

        :returns payments.PaymentReceipt: Instance of PaymentReceipt.
        """
        self.msg_id = msg_id  # type: int

    def to_dict(self):
        return {
            '_': 'GetPaymentReceiptRequest',
            'msg_id': self.msg_id
        }

    def __bytes__(self):
        return b''.join((
            b'\x80\xa9\x92\xa0',
            struct.pack('<i', self.msg_id),
        ))

    @classmethod
    def from_reader(cls, reader):
        _msg_id = reader.read_int()
        return cls(msg_id=_msg_id)


class GetSavedInfoRequest(TLRequest):
    CONSTRUCTOR_ID = 0x227d824b
    SUBCLASS_OF_ID = 0xad3cf146

    def to_dict(self):
        return {
            '_': 'GetSavedInfoRequest'
        }

    def __bytes__(self):
        return b''.join((
            b'K\x82}"',
        ))

    @classmethod
    def from_reader(cls, reader):
        return cls()


class SendPaymentFormRequest(TLRequest):
    CONSTRUCTOR_ID = 0x2b8879b3
    SUBCLASS_OF_ID = 0x8ae16a9d

    def __init__(self, msg_id, credentials, requested_info_id=None, shipping_option_id=None):
        """
        :param int msg_id:
        :param TypeInputPaymentCredentials credentials:
        :param Optional[str] requested_info_id:
        :param Optional[str] shipping_option_id:

        :returns payments.PaymentResult: Instance of either PaymentResult, PaymentVerficationNeeded.
        """
        self.msg_id = msg_id  # type: int
        self.credentials = credentials  # type: TypeInputPaymentCredentials
        self.requested_info_id = requested_info_id  # type: Optional[str]
        self.shipping_option_id = shipping_option_id  # type: Optional[str]

    def to_dict(self):
        return {
            '_': 'SendPaymentFormRequest',
            'msg_id': self.msg_id,
            'credentials': self.credentials.to_dict() if isinstance(self.credentials, TLObject) else self.credentials,
            'requested_info_id': self.requested_info_id,
            'shipping_option_id': self.shipping_option_id
        }

    def __bytes__(self):
        return b''.join((
            b'\xb3y\x88+',
            struct.pack('<I', (0 if self.requested_info_id is None or self.requested_info_id is False else 1) | (0 if self.shipping_option_id is None or self.shipping_option_id is False else 2)),
            struct.pack('<i', self.msg_id),
            b'' if self.requested_info_id is None or self.requested_info_id is False else (self.serialize_bytes(self.requested_info_id)),
            b'' if self.shipping_option_id is None or self.shipping_option_id is False else (self.serialize_bytes(self.shipping_option_id)),
            bytes(self.credentials),
        ))

    @classmethod
    def from_reader(cls, reader):
        flags = reader.read_int()

        _msg_id = reader.read_int()
        if flags & 1:
            _requested_info_id = reader.tgread_string()
        else:
            _requested_info_id = None
        if flags & 2:
            _shipping_option_id = reader.tgread_string()
        else:
            _shipping_option_id = None
        _credentials = reader.tgread_object()
        return cls(msg_id=_msg_id, credentials=_credentials, requested_info_id=_requested_info_id, shipping_option_id=_shipping_option_id)


class ValidateRequestedInfoRequest(TLRequest):
    CONSTRUCTOR_ID = 0x770a8e74
    SUBCLASS_OF_ID = 0x8f8044b7

    def __init__(self, msg_id, info, save=None):
        """
        :param int msg_id:
        :param TypePaymentRequestedInfo info:
        :param Optional[bool] save:

        :returns payments.ValidatedRequestedInfo: Instance of ValidatedRequestedInfo.
        """
        self.msg_id = msg_id  # type: int
        self.info = info  # type: TypePaymentRequestedInfo
        self.save = save  # type: Optional[bool]

    def to_dict(self):
        return {
            '_': 'ValidateRequestedInfoRequest',
            'msg_id': self.msg_id,
            'info': self.info.to_dict() if isinstance(self.info, TLObject) else self.info,
            'save': self.save
        }

    def __bytes__(self):
        return b''.join((
            b't\x8e\nw',
            struct.pack('<I', (0 if self.save is None or self.save is False else 1)),
            struct.pack('<i', self.msg_id),
            bytes(self.info),
        ))

    @classmethod
    def from_reader(cls, reader):
        flags = reader.read_int()

        _save = bool(flags & 1)
        _msg_id = reader.read_int()
        _info = reader.tgread_object()
        return cls(msg_id=_msg_id, info=_info, save=_save)

